
(in-package sugar-qsp)

(eval-when (:compile-toplevel :load-toplevel :execute)
  (defun src-file (filename)
    (uiop/pathname:merge-pathnames*
     filename
     (asdf:system-source-directory :sugar-qsp)))
  (defun compile-ps (filename)
    (format nil "////// Parenscript file: ~A~%~%~A"
            (file-namestring filename) (ps:ps-compile-file filename))))

(defclass compiler ()
  ((body :accessor body :initform #.(alexandria:read-file-into-string (src-file "extras/body.html")))
   (css  :accessor css  :initform (list #.(alexandria:read-file-into-string (src-file "extras/default.css"))))
   (js   :accessor js   :initform (list #.(compile-ps (src-file "src/intrinsics.ps"))
                                        #.(compile-ps (src-file "src/api.ps"))
                                        #.(compile-ps (src-file "src/main.ps"))))
   (compile :accessor compile-only :initarg :compile)
   (target  :accessor target :initarg :target)
   (beautify :accessor beautify :initarg :beautify)))
